function PROFESSOR(dom, xhr) {
	this.dom = dom;
	this.xhr = xhr;	
	this.yatolo = new YATOLO(dom, 'exercice', bind(this.answer, this));
	this.init();
}

PROFESSOR.prototype = {
	init: function() {
		this.dom.$('loader').style.height = this.dom.getDocHeight() + 'px';
		this.dom.$('contentprof').style.height = (this.dom.getDocHeight() - 45) + 'px';
		this.dom.$('lessonsprof').style.height = (this.dom.getDocHeight() - 45 - 49) + 'px';
		this.dom.$('students').style.height = (this.dom.getDocHeight() - 45) + 'px';

		this.dom.on(this.dom.$('home'), 'click', bind(this.home, this));
		this.dom.on(this.dom.$('back'), 'click', bind(this.back, this));
		this.dom.on(this.dom.$('stopexercice'), 'click', bind(this.stopExercice, this));
		
		this.join();
	},
	
	home: function() {
		this.dom.$('lessons').className = '';
		this.dom.$('lessoncontent').className = 'hidden';
		this.dom.$('exercice').className = 'hidden';
		
		this.dom.$('back').className = 'hidden';
		this.dom.$('stopexercice').className = 'hidden';
	},
	
	back: function() {
		this.dom.$('lessoncontent').className = '';
		this.dom.$('exercice').className = 'hidden';
		
		this.dom.$('back').className = 'hidden';
		this.dom.$('stopexercice').className = 'hidden';
	},
	
	stopExercice: function() {
		this.room.chat(JSON.stringify({command: 'stop-exercice'}));
		this.dom.$('stopexercice').className = 'hidden';
	},
	
	join: function() {
		this.room = new ROOM(this.xhr, bind(this.onJoin, this), bind(this.onMessage, this));
		this.room.join('professor');
	},
	
	onJoin: function() {
		this.dom.$('loader').className = 'hidden';
		this.dom.$('contentprof').className = '';
		this.dom.$('students').className = '';
		var url = this.dom.createElemInnerHtml('div', 'url', 'URL : ' + window.location.href.replace('professor.html', ''));
	    this.dom.$('navprof').appendChild(url);
	    this.loadLessons();
	},
	
	loadLessons: function() {
		this.xhr._('GET', '/lessons', null, bind(this.loadLessons_, this));
	},
	
	loadLessons_: function(lessons) {
		this._createList(this.dom.$('lessons'), lessons, bind(this.onLesson, this));
	},
	
	onLesson: function(e) {
		this.dom.$('lessons').className = 'hidden';
		this.dom.$('lessoncontent').className = '';
		var lesson = this.dom.getEvTarget(e, 'li').firstChild.textContent;
		this.loadLesson(lesson);
	},
	
	loadLesson: function(lesson) {
		this.curLesson = lesson;
		this.xhr._('GET', '/lessons/'+urlEncode(this.curLesson), null, bind(this.loadLesson_, this));
	},
	loadLesson_: function(content) {
		this.dom.removeAllChildren(this.dom.$('lessoncontent'));
		this._createList(this.dom.$('lessoncontent'), content, bind(this.onLessonContent, this));
	},
	
	onLessonContent: function(e) {
		this.dom.$('lessoncontent').className = 'hidden';
		this.dom.$('exercice').className = '';
		this.dom.$('back').className = '';
		this.dom.$('stopexercice').className = '';
		var content = this.dom.getEvTarget(e, 'li').firstChild.textContent;
		
		this.yatolo.createIframe(this.curLesson, content);
		this.answers = {};
		this.room.chat(JSON.stringify({command: 'exercice', lesson: this.curLesson, content: content}));
		
		var students = this.dom.$className('student');
		for (var i = 0; i < students.length; i++) {
			students[i].className = 'student student-exerciceSending';
		}
	},
	
	_createList: function(ul, list, handler) {
		for (var i = 0; i < list.length; i++) {
	    	var li = this.dom.createElemInnerHtml('li', '', list[i]);
	    	ul.appendChild(li);
	    }
	    ul.className = '';
	    this.dom.on(ul, 'click', handler);
	},
	
	onMessage: function(m) {
        var m_ = JSON.parse(m.chat);
        switch (m_.command) {
        case 'join': 
        	this.onStudentJoined(m.from);
            break ;
        case 'exercice-received':
        	this.onStudentExerciceReceived(m.from);
        	break ;
        case 'answer':
        	this.onStudentAnswer(m.from, m_.answer);
        	break ;
        default: throw "ERROR";
        };		
	},
	
	onStudentJoined: function(studentName) {
		var student = this.dom.createElemInnerHtml('div', 'student', studentName);
		student.id = this.idify(studentName);
		var students = this.dom.$('students');
		students.appendChild(student);
		students.scrollTop = students.scrollHeight - students.clientHeight;		
	},

	idify: function(studentName) {
		return studentName;
	},
	
	onStudentExerciceReceived: function(studentName) {
		this.dom.$(this.idify(studentName)).className = 'student student-exerciceReceived';
	},
	
	onStudentAnswer: function(studentName, answer) {
		this.answers[this.idify(studentName)] = answer;
		this.dom.$(this.idify(studentName)).className = 'student student-exerciceAnswered';
	},
	
	answer: function(theanswer) {
		this.room.chat(JSON.stringify({command: 'prof-answer', answer: theanswer}));

		var nbDisconnected = 0;
		var nbNoAnswer = 0;
		var nbCorrect = 0;
		var nbBad = 0;
		var students = this.dom.$className('student');
		for (var i = 0; i < students.length; i++) {
			if (students[i].className == 'student student-exerciceSending') {
				this.dom.$('students').removeChild(students[i]);
				nbDisconnected++;
			} else if (students[i].className == 'student student-exerciceReceived') {
				students[i].className = 'student student-noAnswer';
				nbNoAnswer++;
			} else if (this.answers[students[i].id] == theanswer) {
				students[i].className = 'student student-correctAnswer';
				nbCorrect++;
			} else {
				students[i].className = 'student student-badAnswer';
				nbBad++;
			}
		}
		var nbPossibleAnswers = nbCorrect + nbBad + nbNoAnswer;
		
		var msg = '<table>';
		msg += '<tr><td>Nombre de bonnes rponses</td><td>{0}</td><td>{1}%</td></tr>'.replace('{0}', nbCorrect).replace('{1}', nbCorrect * 100 / nbPossibleAnswers);
		msg += '<tr><td>Nombre de mauvaises rponses</td><td>{0}</td><td>{1}%</td></tr>'.replace('{0}', nbBad).replace('{1}', nbBad * 100 / nbPossibleAnswers);
		msg += '<tr><td>Nombre d\'abstentions</td><td>{0}</td><td>{1}%</td></tr>'.replace('{0}', nbNoAnswer).replace('{1}', nbNoAnswer * 100 / nbPossibleAnswers);
		msg += '</table>';
		this.dom.removeAllChildren(this.dom.$('exercice'));
		var tmp = this.dom.createElemInnerHtml('div', 'waiting', msg);
	    this.dom.$('exercice').appendChild(tmp);
	}
};
