function STUDENT(dom, xhr, studentName) {
	this.dom = dom;
	this.xhr = xhr;
	this.studentName = studentName;
	this.yatolo = new YATOLO(dom, 'contentstud', bind(this.answer, this));
	this.init();
}

STUDENT.prototype = {
	init: function() {
		this.dom.$('loader').style.height = this.dom.getDocHeight() + 'px';
		this.dom.$('contentstud').style.height = (this.dom.getDocHeight() - 45) + 'px';
		this.join();
	},
	
	join: function() {
		this.room = new ROOM(this.xhr, bind(this.onJoin, this), bind(this.onMessage, this));
		this.room.join(this.studentName);
	},
	
	onJoin:	function() {
	    this.dom.$('loader').className = 'hidden';
	    this.dom.$('contentstud').className = '';
	    var tmp = this.dom.createElemInnerHtml('div', 'waiting', 'En attente d\'un exercice de la part du professeur');
	    this.dom.$('contentstud').appendChild(tmp);
	},
	
	onMessage: function(m) {
//	    console.log(m);
	    var m_ = JSON.parse(m.chat);
	    switch (m_.command) {
	    case 'exercice': 
	        this.onExercice(m_.lesson, m_.content);
	        break ;
	    case 'prof-answer':
	    	this.onProfAnswer(m_.answer);
	    	break ;
	    case 'stop-exercice':
	    	this.onStopExercice();
	    	break ;
	    default: throw "ERROR";
	    }
	},
	
	onExercice: function(lesson, content) {
		this.answer = null;
		this.yatolo.createIframe(lesson, content);
		this.room.chat(JSON.stringify({command: 'exercice-received'}));
	},
	
	answer: function(theanswer) {
		this.answer = theanswer;
		this.room.chat(JSON.stringify({command: 'answer', answer: theanswer}));
		this.dom.removeAllChildren(this.dom.$('contentstud'));
		var msg = 'Votre rponse a t envoye au professeur : ' + theanswer;
		var tmp = this.dom.createElemInnerHtml('div', 'waiting', msg);
	    this.dom.$('contentstud').appendChild(tmp);
	},
	
	onProfAnswer: function(profanswer) {
		var msg = '<br/>Le professeur a rpondu : ' + profanswer + '<br/>';
		if (! this.answer) {
			msg += 'Dsol, vous n\'avez pas rpondu avant la fin !';
		} else if (this.answer && this.answer == profanswer) {
			msg += 'Bonne rponse !'; 
		} else if (this.answer && this.answer != profanswer) {
			msg += 'Mauvaise rponse !'; 
		}
		var tmp = this.dom.createElemInnerHtml('div', 'waiting', msg);
	    this.dom.$('contentstud').appendChild(tmp);
	},
	
	onStopExercice: function() {
		if (! this.answer) {
			this.dom.removeAllChildren(this.dom.$('contentstud'));
			var msg = 'Le professeur a arrt l\'exercice';
			var tmp = this.dom.createElemInnerHtml('div', 'waiting', msg);
		    this.dom.$('contentstud').appendChild(tmp);
		}
	}
};
